#import "AppController.h"
#include "greg2jul.h"
#include "ephemeride.h"
#include<math.h>

@implementation AppController

- (IBAction)launchCalcul:(id)sender
{
	[NSThread detachNewThreadSelector:@selector(docalcul:) toTarget:self withObject:nil];
}

- (void)docalcul:(id)anObject
{
	// create new autorelease pool for the thread
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

	int Jour=0,Mois=0,Annee=0,UTC_Zone=0,long_d=0,long_m=0,lat_d=0,lat_m=0;
	double longitude,latitude;
	double J,Hcoucher,duree,dureejm1,ecart,transit,declinaison,eqdt,lever,coucher,dls=0;
	char s_ecart[]=" ",s_decl[]=" ",s_eqdt[]=" ";

	long_d = [longitudedegField intValue];
	long_m = [longitudeminField intValue];
	lat_d = [latitudedegField intValue];
	lat_m = [latitudeminField intValue];
	
	longitude = (long_d+((double)long_m)/60)*pow(-1,[longitudeMenu indexOfSelectedItem]);
	latitude = (lat_d+((double)lat_m)/60)*pow(-1,[latitudeMenu indexOfSelectedItem]);
	
	UTC_Zone = [TZField intValue]; // this is in hours
	//if ([dlsButton state]) dls=1; // no need because UTC_Zone is already changed according to this
	sscanf([[dateField stringValue] cString],"%d/%d/%d",&Jour,&Mois,&Annee);
	
	J=greg2jul(Jour,Mois,Annee)+0.5; // jour julien a midi

	ephemeride(J-1,latitude,&Hcoucher,&declinaison,&eqdt); // calcul un jour avant
	dureejm1=2*Hcoucher; // pour avoir la duree du jour precedent
	
	ephemeride(J,latitude,&Hcoucher,&declinaison,&eqdt);

	lever=12-Hcoucher+eqdt/60 +UTC_Zone - longitude/15 +dls;
	coucher=12+Hcoucher+eqdt/60 +UTC_Zone - longitude/15 +dls;
	duree=2*Hcoucher;
	transit=12+eqdt/60 +UTC_Zone - longitude/15 +dls;
	ecart=duree-dureejm1;
	// determination of the sign to print
	if (ecart>=0.) 
		sprintf(s_ecart,"+"); 
	else 
		sprintf(s_ecart," ");
	if ( declinaison < 0. && declinaison > -1.)	
		sprintf(s_decl,"-"); 
	else	
		sprintf(s_decl," ");
	if ( eqdt < 0. && eqdt > -1.)	
		sprintf(s_eqdt,"-"); 
	else	
		sprintf(s_eqdt," ");		

	[eqdtField setStringValue:[NSString stringWithFormat:@"%s%dmin%ds",s_eqdt,(int)eqdt,(int)abs(round((eqdt-(int)eqdt)*60))]];
	[declinaisonField setStringValue:[NSString stringWithFormat:@"%s%d%d'",s_decl,(int)declinaison,(int)abs(round((declinaison-(int)declinaison)*60))]];
	[leverField setStringValue:[NSString stringWithFormat:@"%dh%dmin",(int)floor(lever),(int)round((lever-floor(lever))*60)]];
	[coucherField setStringValue:[NSString stringWithFormat:@"%dh%dmin",(int)floor(coucher),(int)round((coucher-floor(coucher))*60)]];
	[dureeField setStringValue:[NSString stringWithFormat:@"%dh%dmin",(int)floor(duree),(int)round((duree-floor(duree))*60)]];
	[transitField setStringValue:[NSString stringWithFormat:@"%dh%dmin",(int)floor(transit),(int)round((transit-floor(transit))*60)]];
	[ecartField setStringValue:[NSString stringWithFormat:@"%s%dmin",s_ecart,(int)round(ecart*60)]];

	// release the autorelease pool
	[pool release];
}

- (IBAction)setDate:(id)sender
{
	[self setLocalDateInfo];	
}

//since this is a single window app, quit when window closes
-(BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication
{
	return YES;
}

-(void)awakeFromNib
{
  [self setLocalDateInfo];
}

-(void)setLocalDateInfo
{
	NSTimeZone *local_zone = [NSTimeZone systemTimeZone];
	NSCalendarDate *local_date= [NSCalendarDate calendarDate];
	
	[dateField setStringValue:[local_date descriptionWithCalendarFormat:@"%d/%m/%Y"]];
	if ([local_zone isDaylightSavingTime]){
		//NSLog(@"Daylight Saving: Yes");
		[dlsButton setState:NSOnState];
	}
	else {
		//NSLog(@"Daylight Saving: No");
		[dlsButton setState:NSOffState];
	}
	//NSLog(@"Seconds : %d",[local_zone secondsFromGMT]);
	[TZField setStringValue:[NSString stringWithFormat:@"%d",[local_zone secondsFromGMT]/3600]];

}	

@end
