/*
 *  ephemeride.c
 *  ephemeride
 *
 *  Created by Alexandre Vial on Wed Dec 29 2004.
 *  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
 *
 */

#include "ephemeride_data.h"
#include "ephemeride.h"
#include<math.h>

void ephemeride(double J,double lat,double *Hcoucher,double *declinaison,double *eqdt){
	double M,C,lambda_s,R;

	M=M_0+M_1*J;
	C=C_1*sin(M*M_PI/180)+C_2*sin(2.*M*M_PI/180)+C_3*sin(3*M*M_PI/180);
	lambda_s=M+LONG_ECL+C+180;

	R=A_2*sin(2*lambda_s*M_PI/180)+A_4*sin(4*lambda_s*M_PI/180)+A_6*sin(6*lambda_s*M_PI/180);

	*eqdt=(R+C)*4;
	*declinaison = D_1*sin(lambda_s*M_PI/180)+D_3*pow(sin(lambda_s*M_PI/180),3)+D_5*pow(sin(lambda_s*M_PI/180),5);
	//*Hlever = -acos( (sin(h_0*M_PI/180)-sin(lat*M_PI/180)*sin(*declinaison*M_PI/180)) / (cos(lat*M_PI/180)*cos(*declinaison*M_PI/180)))/2/M_PI*24;
	*Hcoucher =acos( (sin(h_0*M_PI/180)-sin(lat*M_PI/180)*sin(*declinaison*M_PI/180)) / (cos(lat*M_PI/180)*cos(*declinaison*M_PI/180)))/2/M_PI*24;
}